/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;
import de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatUK;

public abstract class AbstractDirektkandidatDAO extends de.ivu.elect.jee.entity.AbstractDAO<Direktkandidat,
      de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
  , DirektkandidatUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractDirektkandidatDAO.class);

  public AbstractDirektkandidatDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Direktkandidat findByPrimaryKey(
      de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
    pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Direktkandidat findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Direktkandidat.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: GebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS(SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet.gebiet = ?1 AND gruppeImGebiet = wahlvorschlag.gruppeImGebiet)<br>
      * SQL: <br>
      */
     public java.util.List<Direktkandidat> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("DIREKTKANDIDAT.Gebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Direktkandidat, findByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GruppeAndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS (SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet = wahlvorschlag.gruppeImGebiet AND gruppeImGebiet.gruppe = ?1 AND gruppeImGebiet.gebiet = ?2)<br>
      * SQL: <br>
      */
     public java.util.List<Direktkandidat> findByGruppeAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("DIREKTKANDIDAT.GruppeAndGebiet")
                              .setParameter(1, gruppeCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGruppeAndGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Direktkandidat, findByGruppeAndGebiet - NonUniqueResultException, Parameter: "
           + ", gruppe:'"+gruppe+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGruppeAndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatUK uk,
      de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagPK
    pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat findByUK(de.ivu.elect.business.wahlvorschlag.entity.DirektkandidatUK uk){

    try {
     return (de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat) getEntityManager().createNamedQuery("DIREKTKANDIDAT.UK")
                  .setParameter(1, uk
                .getDiscriminator ()

              )
             .setParameter(2, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getNummer ()

              )
             .setParameter(3, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getGebietsartUK ()

                .getName ()

              )
             .setParameter(4, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getGebietsartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(5, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(6, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(7, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(8, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(9, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(10, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(11, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(12, uk
                .getGruppeImGebietUK ()

                .getGebietUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(13, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getSchluessel ()

              )
             .setParameter(14, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(15, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(16, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(17, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(18, uk
                .getGruppeImGebietUK ()

                .getGruppeUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Direktkandidat, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}